#include <WiFi.h>
#include <ESPmDNS.h>
#include <SPIFFS.h>
#include <WiFiClient.h>
#include <string.h>
#include <FS.h>
#include <WebServer.h>

WebServer server(80);

#define debug true
#define SetupPin 22   // INI wifimanager starten mit LOW-Pegel an SetupPin

#include "INIwifimanager.h"
String ssid, password, host;

  //******************************************************************************
  //  Diese Funktion wird beim lesen eder Zeile der INI-Datei ausgeführt         *
  //******************************************************************************
void DatenLaden (String argument, String Wert)
{
if (argument.indexOf ( "ssid" ) >= 0)       ssid = Wert;
if (argument.indexOf ( "passwort" ) >= 0)   password = Wert; 
if (argument.indexOf ( "hostname" ) >= 0)   host = Wert; 
}

void setup()
{
  char inser;
  Serial.begin(115200);
  Serial.println("");
  if (!INI_Einlesen()) Einstellen();     // INI -Datei einlesen, wenn geht nicht, starte INI WiFiManager

  //******************************************************************************
  //         Setup Weiche, Erkennen ob TXD/RXD gebrückt sind                     *
  //******************************************************************************
  while (Serial.available())inser = Serial.read();  // RX - Buffer leern
  Serial.println("Start");
  delay(10);
  inser = Serial.read();
  if (inser != 'S') goto weiter;
  inser = Serial.read();
  if (inser != 't') goto weiter;
  Einstellen();         // starte INI WiFiManager  wenn TXD / RXD verbunden sind
weiter:
  //******************************************************************************
  pinMode(SetupPin, INPUT_PULLUP);       // starte INI WiFiManager wenn SetupPin Low ist
  if (!digitalRead(SetupPin)) Einstellen();

  //******************************************************************************
  //                       Starte WiFi Verbindung                                *
  //******************************************************************************
  if (debug)Serial.println("Warte auf Verbindung");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid.c_str(), password.c_str());
  Serial.println("");
  int timeout = 20;          // versuche 10 sekunden zu verbinden
  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    if (debug) Serial.print(".");
    timeout--;
    if (!timeout)
    {
      if (debug) Serial.println("");
      if (debug) Serial.println("Verbindung zum " + ssid + " klappt nicht!");
      Einstellen();  // starte INI WiFiManager, wenn verbindung mit WLAN  fehlschlaegt
    }
  }
  if (debug) Serial.println("");
  if (debug) Serial.print("IP Addresse: ");
  if (debug) Serial.println(WiFi.localIP());
  MDNS.begin(host.c_str());
  if (debug) Serial.println("Offnen Sie http://"+ host +".local in Ihrem Browser");

  server.onNotFound([]() {
    server.send(404, "text/plain", "FileNotFound");
  });

  server.on("/", []() {         // index.html an Browser senden
    File file = SPIFFS.open("/index.html", "r");
    size_t sent = server.streamFile(file, "text/html");
    file.close();
  });

  server.begin();
  if (debug)Serial.println("HTTP Server gestartet");
}

void loop()
{
  server.handleClient();
}
